"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunk7FPSHSSOcjs = require('./chunk-7FPSHSSO.cjs');

// src/browser/localstorage.ts
var LocalStorage = class {
  constructor(opt) {
    this.pretty = false;
    this.name = _nullishCoalesce(opt.name, () => ( "zeed"));
    this.prefix = `${opt.name}$`;
    this.objectToString = _nullishCoalesce(opt.objectToString, () => ( ((data) => {
      return this.pretty ? _chunk7FPSHSSOcjs.jsonStringifySafe.call(void 0, data, null, 2) : _chunk7FPSHSSOcjs.jsonStringifySafe.call(void 0, data);
    })));
    this.objectFromString = _nullishCoalesce(opt.objectFromString, () => ( ((data) => {
      try {
        return JSON.parse(data);
      } catch (err) {
      }
    })));
  }
  setItem(key, value) {
    const data = this.objectToString(value);
    localStorage.setItem(`${this.prefix}${key}`, data);
  }
  getItem(key) {
    const value = localStorage.getItem(`${this.prefix}${key}`);
    if (value != null)
      return this.objectFromString(value);
  }
  removeItem(key) {
    localStorage.removeItem(`${this.prefix}${key}`);
  }
  clear() {
    Object.keys(localStorage).filter((key) => key.startsWith(this.prefix)).forEach((key) => {
      localStorage.removeItem(key);
    });
  }
  allKeys() {
    const prefixLength = this.prefix.length;
    return Object.keys(localStorage).filter((key) => key.startsWith(this.prefix)).map((key) => key.substr(prefixLength));
  }
};



exports.LocalStorage = LocalStorage;
//# sourceMappingURL=chunk-COSI24MV.cjs.map