"use strict";Object.defineProperty(exports, "__esModule", {value: true});


var _chunkPOMZSIODcjs = require('./chunk-POMZSIOD.cjs');

// src/common/data/object.ts
function objectMap(obj, fn) {
  if (!_chunkPOMZSIODcjs.isObject.call(void 0, obj))
    return {};
  return Object.fromEntries(
    Object.entries(obj).map(([k, v]) => {
      const r = fn(k, v);
      if (_chunkPOMZSIODcjs.isArray.call(void 0, r) && r.length === 2)
        return r;
      return [k, r];
    }).filter((v) => v != null)
  );
}
function objectMergeDisposable(a, b) {
  if (b.dispose && a.dispose) {
    b.dispose.add(a.dispose);
  }
  return Object.assign(a, b);
}
function objectIsEmpty(obj) {
  return Object.keys(obj).length <= 0;
}
function objectPick(obj, ...keys) {
  return Object.fromEntries(keys.filter((key) => key in obj).map((key) => [key, obj[key]]));
}
function objectInclusivePick(obj, ...keys) {
  return Object.fromEntries(keys.map((key) => [key, obj[key]]));
}
function objectOmit(obj, ...keys) {
  return Object.fromEntries(Object.entries(obj).filter(([key]) => !keys.includes(key)));
}








exports.objectMap = objectMap; exports.objectMergeDisposable = objectMergeDisposable; exports.objectIsEmpty = objectIsEmpty; exports.objectPick = objectPick; exports.objectInclusivePick = objectInclusivePick; exports.objectOmit = objectOmit;
//# sourceMappingURL=chunk-DYQJ5GN4.cjs.map