import {
  useLevelFilter,
  useNamespaceFilter
} from "./chunk-GUPXJFTH.js";
import {
  getTimestamp
} from "./chunk-GVJPPBQD.js";

// src/common/log/log-memory.ts
function LoggerMemoryHandler(opt) {
  const { level = void 0, filter = void 0, messages = [] } = opt;
  const matchesNamespace = useNamespaceFilter(filter);
  const matchesLevel = useLevelFilter(level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    msg.timestamp = getTimestamp();
    messages.push(msg);
  };
}

export {
  LoggerMemoryHandler
};
//# sourceMappingURL=chunk-JNJ7FFGY.js.map