"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkMFFYNVHWcjs = require('./chunk-MFFYNVHW.cjs');


var _chunkNDRXN4NKcjs = require('./chunk-NDRXN4NK.cjs');


var _chunkO3QYDQEHcjs = require('./chunk-O3QYDQEH.cjs');


var _chunkCEXYDYSHcjs = require('./chunk-CEXYDYSH.cjs');

// src/common/exec/progress.ts
var Progress = class _Progress extends _chunkMFFYNVHWcjs.Emitter {
  constructor(opt = {}) {
    super();
    this._isCancelled = false;
    this._resetWhenFinished = true;
    this._children = [];
    this.dispose = _chunkO3QYDQEHcjs.useDispose.call(void 0, );
    this._totalUnits = _nullishCoalesce(opt.totalUnits, () => ( 0));
    this._completedUnits = _nullishCoalesce(opt.completeUnits, () => ( 0));
    this._resetWhenFinished = _nullishCoalesce(opt.resetWhenFinished, () => ( true));
    this.name = _nullishCoalesce(opt.name, () => ( _chunkNDRXN4NKcjs.uname.call(void 0, "progress")));
    this.dispose.add(async () => {
      for (const child of this._children)
        await child.dispose();
      await this.emit("progressDispose", this);
    });
  }
  /** Notify others about changes and reset on completion, if flag is set. */
  update() {
    void this.emit("progressChanged", this);
    if (this._isCancelled && this._resetWhenFinished) {
      if (this.getTotalUnits() <= this.getCompletedUnits())
        this.reset();
    }
  }
  /** Fresh start */
  reset() {
    if (this._isCancelled) {
      this._isCancelled = false;
      for (const child of this._children)
        child.reset();
      this.update();
    }
  }
  /** Notify and mark as cancelled. May take some time before having an effect. */
  async cancel() {
    if (!this._isCancelled) {
      this._isCancelled = true;
      await this.emit("progressCancelled", this);
      for (const child of this._children)
        await child.cancel();
      this.update();
    }
  }
  /** Add child progress, which count into its parents units. On `dispose` it will auto remove itself from parent. */
  addChild(child) {
    child.on("progressDispose", () => this.removeChild(child));
    child.on("progressChanged", () => this.update());
    if (!this._children.includes(child))
      this._children.push(child);
    this.update();
  }
  /** Create child progress.  */
  createChildProgress(opt) {
    const progress = new _Progress(opt);
    this.addChild(progress);
    return progress;
  }
  removeChild(child) {
    _chunkCEXYDYSHcjs.arrayRemoveElement.call(void 0, this._children, child);
    this.update();
  }
  /** Total units including children */
  getTotalUnits() {
    if (this.isIndeterminate())
      return 0;
    let units = this._totalUnits;
    for (const child of this._children)
      units += child.getTotalUnits();
    return units;
  }
  /** Completed units including children */
  getCompletedUnits() {
    if (this.isIndeterminate())
      return 0;
    let units = this._completedUnits;
    for (const child of this._children)
      units += child.getCompletedUnits();
    return units;
  }
  /** Cannot calculate progress, because totalUnits are missing. Special representation in UI. */
  isIndeterminate() {
    return this._totalUnits <= 0 && this._children.length <= 0;
  }
  isCancelled() {
    return this._isCancelled;
  }
  /** Either disposed or all units completed. */
  isFinished() {
    return this.dispose.isDisposed() || !this.isIndeterminate() && this.getTotalUnits() <= this.getCompletedUnits();
  }
  /** Value from 0 to 1, where 1 is 100% completeness. */
  getFraction() {
    if (this.isIndeterminate())
      return 0;
    let value = this.getCompletedUnits() / this.getTotalUnits();
    if (Number.isNaN(value))
      value = 0;
    return Math.min(1, Math.max(0, value));
  }
  getChildrenCount() {
    return this._children.length;
  }
  /** Change total units. */
  setTotalUnits(units, completedUnits) {
    this._totalUnits = units;
    if (completedUnits != null)
      this._completedUnits = completedUnits;
    this.update();
  }
  /** Relatively change total units. */
  incTotalUnits(step = 1) {
    this._totalUnits += step;
    this.update();
  }
  /** Set fixed number of completed units. */
  setCompletetedUnits(units) {
    this._completedUnits = units;
    this.update();
  }
  /** Set to 100% without disposing. */
  setCompleted() {
    this._completedUnits = this._totalUnits;
    this.update();
  }
  /** Dynamically change completed units. */
  incCompletedUnits(step = 1) {
    this._completedUnits += step;
    this.update();
  }
  /** Progress tree to string for debuggin purposes. Consider using `name` attribute of Progress. */
  toString(indent = 0) {
    let s = `${"  ".repeat(indent)}${this.name}: ${this._completedUnits} of ${this._totalUnits} units, ${Math.floor(this.getFraction() * 100)} %, cancel=${this._isCancelled}
`;
    for (const child of this._children)
      s += child.toString(indent + 1);
    if (indent === 0)
      return s.trim();
    return s;
  }
};



exports.Progress = Progress;
//# sourceMappingURL=chunk-P5QKVIMC.cjs.map