import {
  getSecureRandomIfPossible
} from "./chunk-IZT6OHMS.js";

// src/common/data/sortable.ts
function startSortWeight(items) {
  return items.reduce((acc, item) => Math.min(acc, item.sort_weight || 0), 0) - 1 - getSecureRandomIfPossible();
}
function endSortWeight(items) {
  return items.reduce((acc, item) => Math.max(acc, item.sort_weight || 0), 0) + 1 + getSecureRandomIfPossible();
}
function moveSortWeight(newIndex, oldIndex, items) {
  const count = items.length;
  const moveLower = newIndex < oldIndex;
  if (count <= 0 || newIndex >= count - 1)
    return endSortWeight(items);
  if (newIndex <= 0)
    return startSortWeight(items);
  items = sortedItems([...items]);
  const step = moveLower ? -1 : 0;
  const lower = items[newIndex + step].sort_weight || 0;
  const upper = items[newIndex + step + 1].sort_weight || 0;
  const distance = upper - lower;
  if (distance === 0) {
    if (moveLower)
      return startSortWeight(items);
    return endSortWeight(items);
  }
  const middle = lower + distance / 2;
  const fuzzy = distance * 0.01 * (getSecureRandomIfPossible() - 0.5);
  return middle + fuzzy;
}
function sortedItems(items) {
  items.sort((a, b) => (a.sort_weight || 0) - (b.sort_weight || 0));
  return items;
}

export {
  startSortWeight,
  endSortWeight,
  moveSortWeight,
  sortedItems
};
//# sourceMappingURL=chunk-X2DIUKLP.js.map