/**
 * Original at https://github.com/dmonad/lib0
 *
 * Utility functions to work with buffers (Uint8Array).
 */
declare function createUint8ArrayFromLen(len: number): Uint8Array;
/**
 * Copy the content of an Uint8Array view to a new ArrayBuffer.
 */
declare function copyUint8Array(uint8Array: Uint8Array): Uint8Array;
/**
 * Encode anything as a UInt8Array. It's a pun on typescripts's `any` type.
 * See encoding.writeAny for more information.
 */
declare function encodeAny(data: any): Uint8Array;
/**
 * Decode an any-encoded value.
 */
declare function decodeAny(buf: Uint8Array): any;

export { copyUint8Array, createUint8ArrayFromLen, decodeAny, encodeAny };
