import "../chunk-HMRSQHLY.js";
import "../chunk-UMUHNSGZ.js";
import "../chunk-SRT6T6F5.js";
import "../chunk-INP3FSCD.js";
import "../chunk-XDFLBYG5.js";
import "../chunk-MKG75UEC.js";
import "../chunk-MWUFUBY5.js";
import "../chunk-GKKLBSFA.js";
import "../chunk-RNL46FQ3.js";
import "../chunk-BJGZAXQX.js";
import "../chunk-THQONF76.js";
import "../chunk-FLFB2K34.js";
import "../chunk-264HKVNG.js";
import "../chunk-HST4VI64.js";
import "../chunk-JZMQBHAJ.js";
import "../chunk-A7SUGWC3.js";
import "../chunk-PXMCFDHI.js";
import "../chunk-O3EVCWNG.js";
import "../chunk-EW6FHLFK.js";
import "../chunk-LXSAZMHZ.js";
import "../chunk-MPAXUMZ5.js";
import "../chunk-PJDBG5VS.js";
import "../chunk-B4LURUT2.js";
import "../chunk-63QPAGBX.js";
import "../chunk-7OAUULYN.js";
import "../chunk-IQFZHKL7.js";
import "../chunk-4IZFBMWE.js";
import "../chunk-WFPP4REE.js";
import "../chunk-AJ3WFXQE.js";
import "../chunk-KVZOYAMV.js";
import "../chunk-FZ5R2SNB.js";
import "../chunk-FVTKBBFT.js";
import "../chunk-KGD7JR27.js";
import "../chunk-7GOLOL5D.js";
import "../chunk-JNJ7FFGY.js";
import {
  DefaultLogger
} from "../chunk-VAS3X5GJ.js";
import "../chunk-GAKRSKPV.js";
import "../chunk-455C43FU.js";
import "../chunk-CFICINSP.js";
import {
  decrypt,
  deriveKeyPbkdf2,
  digest,
  encrypt,
  randomUint8Array
} from "../chunk-RG6OSZW5.js";
import "../chunk-I45WP5PM.js";
import "../chunk-GUPXJFTH.js";
import "../chunk-WXJDMWFH.js";
import "../chunk-GVJPPBQD.js";
import "../chunk-UHTVWILC.js";
import "../chunk-T7PU5CTZ.js";
import "../chunk-XSB2WAW2.js";
import "../chunk-AS5LR4AI.js";
import "../chunk-5Y3HYG6B.js";
import "../chunk-AFUVZLZZ.js";
import "../chunk-X2DIUKLP.js";
import "../chunk-NYCGHEIN.js";
import "../chunk-NC5D7QLN.js";
import "../chunk-FL5CT6MC.js";
import "../chunk-2HWPZ6ZE.js";
import "../chunk-HLRQ5H3N.js";
import "../chunk-BCFBEP5B.js";
import "../chunk-EOHXRMVQ.js";
import "../chunk-DGP32WEQ.js";
import "../chunk-73CVRDI7.js";
import "../chunk-66LHCCNT.js";
import "../chunk-4XPO57AQ.js";
import "../chunk-ACZDEHYB.js";
import "../chunk-FSDCRQB3.js";
import "../chunk-YEEGQOIW.js";
import "../chunk-AEBHR4XF.js";
import "../chunk-IZT6OHMS.js";
import "../chunk-GY34N3KU.js";
import "../chunk-NS4INNCL.js";
import "../chunk-TYWNSO7K.js";
import "../chunk-ZMFW3O35.js";
import "../chunk-R6KULE2F.js";
import "../chunk-7NSVDPHN.js";
import {
  equalBinary,
  toHex
} from "../chunk-VVNSHVPQ.js";
import "../chunk-6GHO7LQW.js";

// src/common/crypto.spec.ts
var log = DefaultLogger("crypto.spec");
describe("crypto", () => {
  it("should not have collisions", () => {
    expect(equalBinary(new Uint8Array(2), new Uint8Array([0, 0]))).toBe(true);
    const list = Array.apply(null, Array(100)).map(
      () => randomUint8Array(8)
    );
    let id;
    while (id = list.pop()) {
      expect(equalBinary(id, new Uint8Array([0, 0, 0, 0, 0, 0, 0, 0]))).toBe(
        false
      );
      expect(id?.length).toBe(8);
      expect(list).not.toContain(id);
    }
  });
  it("should digest", async () => {
    expect(toHex(await digest("abc"))).toBe(
      "ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad"
    );
    expect(await digest(new Uint8Array([1, 2, 3]))).toMatchInlineSnapshot(`
Uint8Array [
  3,
  144,
  88,
  198,
  242,
  192,
  203,
  73,
  44,
  83,
  59,
  10,
  77,
  20,
  239,
  119,
  204,
  15,
  120,
  171,
  204,
  206,
  213,
  40,
  125,
  132,
  161,
  162,
  1,
  28,
  251,
  129,
]
`);
  });
  it("should raw crypt", async () => {
    const key = await deriveKeyPbkdf2(new Uint8Array([1, 2, 3]), {
      salt: new Uint8Array([1, 2, 3])
    });
    const sample = new Uint8Array([9, 8, 7, 6, 5, 4, 3, 2, 1, 0]);
    const cipher = await encrypt(sample, key);
    const bin = await decrypt(cipher, key);
    expect(equalBinary(sample, bin)).toBe(true);
    const binFix = await decrypt(
      new Uint8Array([
        1,
        1,
        27,
        108,
        252,
        31,
        238,
        192,
        61,
        168,
        45,
        29,
        128,
        212,
        215,
        222,
        205,
        105,
        178,
        193,
        150,
        36,
        24,
        216,
        180,
        75,
        168,
        133,
        37,
        25,
        124,
        137,
        221,
        103,
        214,
        97,
        218,
        232,
        248,
        93
      ]),
      key
    );
    expect(binFix).toEqual(sample);
  });
});
//# sourceMappingURL=crypto.spec.js.map