"use strict";require('../../chunk-XG57S66T.cjs');
require('../../chunk-QKGNMC5N.cjs');


var _chunkJSDQUV2Fcjs = require('../../chunk-JSDQUV2F.cjs');
require('../../chunk-RJM35BFG.cjs');
require('../../chunk-BKBCRA55.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-37DK2SKC.cjs');
require('../../chunk-JSBFJVKM.cjs');
require('../../chunk-ST3SZ2ML.cjs');
require('../../chunk-CXBBK7CI.cjs');
require('../../chunk-R7WMTFSS.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-7XAMJGPO.cjs');
require('../../chunk-RKOTNV3K.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-DYQJ5GN4.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-YELWQAMG.cjs');




var _chunkAZ5FKZIKcjs = require('../../chunk-AZ5FKZIK.cjs');
require('../../chunk-POMZSIOD.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-XO4K2T3A.cjs');
require('../../chunk-3SM3C7HY.cjs');
require('../../chunk-UXNJ5WZM.cjs');
require('../../chunk-QYCE2TUJ.cjs');
require('../../chunk-ANZPWIO4.cjs');
require('../../chunk-CEXYDYSH.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-XDY4SRCL.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-QU2LM4AI.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-66YRDFQP.cjs');
require('../../chunk-7FPSHSSO.cjs');

// src/common/data/deep.spec.ts
var log = _chunkJSDQUV2Fcjs.DefaultLogger.call(void 0, "test:deep");
describe("deep", () => {
  it("should deep without self reference", () => {
    const sample = {
      a: 1
    };
    sample.b = sample;
    const sample2 = {
      a: 1
    };
    sample2.b = sample2;
    log("sample", sample);
    expect(_chunkAZ5FKZIKcjs.deepEqual.call(void 0, sample, sample2)).toBe(false);
  });
  it("should compare arays", () => {
    const a = [1, 2, 3];
    const b = [3, 2, 1];
    expect(_chunkAZ5FKZIKcjs.deepEqual.call(void 0, a, b)).toBe(false);
    const c = [3, 2, 1, 0];
    expect(_chunkAZ5FKZIKcjs.deepEqual.call(void 0, a, c)).toBe(false);
  });
  it("should simple checks", () => {
    const value = new String("Hello");
    expect(typeof value === "object").toBe(true);
    expect(value.valueOf()).toBe("Hello");
    expect(new String(value).valueOf()).toBe("Hello");
  });
  it("should merge deep", () => {
    const a = {
      hello: {
        world: 42
      },
      before: {
        magic: 666
      }
    };
    const b = {
      hello: {
        world: -1,
        sea: "none"
      },
      other: {
        fish: 2
      }
    };
    const c = {
      other: {
        fish: 8
      }
    };
    const d = _chunkAZ5FKZIKcjs.deepMerge.call(void 0, a, b, c);
    expect(d).toEqual({
      hello: {
        world: -1,
        sea: "none"
      },
      other: {
        fish: 8
      },
      before: {
        magic: 666
      }
    });
  });
  it("should strip undefined", () => {
    const sample = {
      hello: {
        world: -1,
        null1: null,
        undefined1: void 0,
        sea: "none"
      },
      undefined1: void 0,
      other: [
        {
          fish: 8,
          undefined1: void 0
        },
        void 0,
        null,
        "Hello"
      ],
      before: {
        magic: 666
      }
    };
    expect(JSON.stringify(sample, null, 2)).toMatchInlineSnapshot(`
      "{
        "hello": {
          "world": -1,
          "null1": null,
          "sea": "none"
        },
        "other": [
          {
            "fish": 8
          },
          null,
          null,
          "Hello"
        ],
        "before": {
          "magic": 666
        }
      }"
    `);
    expect(_chunkAZ5FKZIKcjs.deepStripUndefinedInPlace.call(void 0, sample)).toMatchInlineSnapshot(`
      Object {
        "before": Object {
          "magic": 666,
        },
        "hello": Object {
          "null1": null,
          "sea": "none",
          "world": -1,
        },
        "other": Array [
          Object {
            "fish": 8,
            "undefined1": undefined,
          },
          null,
          "Hello",
        ],
      }
    `);
  });
});
//# sourceMappingURL=deep.spec.cjs.map