import "../../chunk-HMRSQHLY.js";
import "../../chunk-UMUHNSGZ.js";
import "../../chunk-SRT6T6F5.js";
import "../../chunk-INP3FSCD.js";
import "../../chunk-XDFLBYG5.js";
import "../../chunk-MKG75UEC.js";
import "../../chunk-MWUFUBY5.js";
import "../../chunk-GKKLBSFA.js";
import "../../chunk-RNL46FQ3.js";
import "../../chunk-BJGZAXQX.js";
import "../../chunk-THQONF76.js";
import "../../chunk-FLFB2K34.js";
import "../../chunk-264HKVNG.js";
import "../../chunk-HST4VI64.js";
import "../../chunk-JZMQBHAJ.js";
import "../../chunk-A7SUGWC3.js";
import "../../chunk-PXMCFDHI.js";
import "../../chunk-O3EVCWNG.js";
import "../../chunk-EW6FHLFK.js";
import "../../chunk-LXSAZMHZ.js";
import "../../chunk-MPAXUMZ5.js";
import "../../chunk-PJDBG5VS.js";
import "../../chunk-B4LURUT2.js";
import "../../chunk-63QPAGBX.js";
import "../../chunk-7OAUULYN.js";
import "../../chunk-IQFZHKL7.js";
import "../../chunk-4IZFBMWE.js";
import "../../chunk-WFPP4REE.js";
import "../../chunk-AJ3WFXQE.js";
import "../../chunk-KVZOYAMV.js";
import "../../chunk-FZ5R2SNB.js";
import "../../chunk-FVTKBBFT.js";
import "../../chunk-KGD7JR27.js";
import "../../chunk-7GOLOL5D.js";
import "../../chunk-JNJ7FFGY.js";
import "../../chunk-VAS3X5GJ.js";
import "../../chunk-GAKRSKPV.js";
import "../../chunk-455C43FU.js";
import "../../chunk-CFICINSP.js";
import "../../chunk-RG6OSZW5.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-GUPXJFTH.js";
import "../../chunk-WXJDMWFH.js";
import "../../chunk-GVJPPBQD.js";
import "../../chunk-UHTVWILC.js";
import "../../chunk-T7PU5CTZ.js";
import "../../chunk-XSB2WAW2.js";
import "../../chunk-AS5LR4AI.js";
import "../../chunk-5Y3HYG6B.js";
import "../../chunk-AFUVZLZZ.js";
import "../../chunk-X2DIUKLP.js";
import {
  useSorted
} from "../../chunk-NYCGHEIN.js";
import "../../chunk-NC5D7QLN.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-2HWPZ6ZE.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-BCFBEP5B.js";
import "../../chunk-EOHXRMVQ.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-66LHCCNT.js";
import "../../chunk-4XPO57AQ.js";
import "../../chunk-ACZDEHYB.js";
import "../../chunk-FSDCRQB3.js";
import "../../chunk-YEEGQOIW.js";
import {
  arrayShuffleForce,
  arrayShuffleInPlace
} from "../../chunk-AEBHR4XF.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-NS4INNCL.js";
import "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import {
  last
} from "../../chunk-R6KULE2F.js";
import "../../chunk-7NSVDPHN.js";
import "../../chunk-VVNSHVPQ.js";
import "../../chunk-6GHO7LQW.js";

// src/common/data/sorted.spec.ts
describe("sorted", () => {
  const sorted = useSorted();
  const list = [-0.2, -1e-3, 0, 1e-3, 2];
  const items = list.map((sort, index) => ({ index, sort }));
  it("should add correctly", () => {
    expect(sorted.start(items)).toBeLessThan(list[0]);
    expect(sorted.end(items)).toBeGreaterThan(last(list) || 0);
  });
  it("should sort correctly", () => {
    const shuffledItems = arrayShuffleForce(items);
    expect(shuffledItems.map((el) => el.sort)).not.toEqual(list);
    expect(sorted.items(shuffledItems).map((el) => el.sort)).toEqual(list);
  });
  it("should move correctly", () => {
    let items2 = [];
    for (let i = 0; i < 10; i++) {
      items2.push({
        name: String(i),
        sort: i
      });
    }
    expect(
      sorted.items(items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
    const moveItem = items2[8];
    moveItem.sort = sorted.move(1, 8, items2);
    expect(
      sorted.items(items2).map((o) => o.name).join("")
    ).toEqual("0812345679");
    items2 = sorted.items(items2);
    const moveItem2 = items2[1];
    arrayShuffleInPlace(items2);
    moveItem2.sort = sorted.move(8, 1, items2);
    expect(
      sorted.items(items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
  });
});
//# sourceMappingURL=sorted.spec.js.map