import "../../chunk-EW6FHLFK.js";
import "../../chunk-LXSAZMHZ.js";
import "../../chunk-MPAXUMZ5.js";
import "../../chunk-PJDBG5VS.js";
import "../../chunk-B4LURUT2.js";
import "../../chunk-63QPAGBX.js";
import "../../chunk-7OAUULYN.js";
import "../../chunk-IQFZHKL7.js";
import "../../chunk-4IZFBMWE.js";
import "../../chunk-WFPP4REE.js";
import "../../chunk-AJ3WFXQE.js";
import "../../chunk-KVZOYAMV.js";
import "../../chunk-FZ5R2SNB.js";
import "../../chunk-FVTKBBFT.js";
import "../../chunk-KGD7JR27.js";
import "../../chunk-7GOLOL5D.js";
import "../../chunk-JNJ7FFGY.js";
import "../../chunk-VAS3X5GJ.js";
import "../../chunk-GAKRSKPV.js";
import "../../chunk-455C43FU.js";
import "../../chunk-CFICINSP.js";
import "../../chunk-RG6OSZW5.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-GUPXJFTH.js";
import "../../chunk-WXJDMWFH.js";
import "../../chunk-GVJPPBQD.js";
import "../../chunk-UHTVWILC.js";
import "../../chunk-T7PU5CTZ.js";
import "../../chunk-XSB2WAW2.js";
import "../../chunk-AS5LR4AI.js";
import "../../chunk-5Y3HYG6B.js";
import "../../chunk-AFUVZLZZ.js";
import "../../chunk-X2DIUKLP.js";
import "../../chunk-NYCGHEIN.js";
import "../../chunk-NC5D7QLN.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-2HWPZ6ZE.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-BCFBEP5B.js";
import "../../chunk-EOHXRMVQ.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-66LHCCNT.js";
import "../../chunk-4XPO57AQ.js";
import "../../chunk-ACZDEHYB.js";
import {
  sleep
} from "../../chunk-FSDCRQB3.js";
import "../../chunk-YEEGQOIW.js";
import "../../chunk-AEBHR4XF.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-NS4INNCL.js";
import "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import {
  cloneObject,
  empty,
  ensureKey,
  forTimes,
  memoize,
  memoizeAsync,
  size
} from "../../chunk-R6KULE2F.js";
import "../../chunk-7NSVDPHN.js";
import "../../chunk-VVNSHVPQ.js";
import "../../chunk-6GHO7LQW.js";

// src/common/data/utils.spec.ts
describe("cloneObject", () => {
  it("should clone only non primitives", () => {
    {
      const sample = "Test";
      expect(cloneObject(sample) === sample).toBe(true);
      expect(cloneObject(sample) === "Test").toBe(true);
    }
    {
      const sample = { hello: "world" };
      expect(cloneObject(sample) === sample).toBe(false);
      expect(cloneObject(sample)).toEqual(sample);
      expect(cloneObject(sample)).toEqual({ hello: "world" });
    }
  });
});
describe("size", () => {
  it("should calc size of map", () => {
    const map = /* @__PURE__ */ new Map();
    map.set("a", 1);
    map.set("b", 2);
    expect(size(map)).toBe(2);
  });
  it("should calc size of set", () => {
    const set = /* @__PURE__ */ new Set();
    set.add(1);
    set.add(2);
    set.add(3);
    expect(size(set)).toBe(3);
  });
  it("should calc size of object", () => {
    expect(size({ a: 1, b: 2 })).toBe(2);
  });
  it("should calc size of array", () => {
    expect(size([1, 2, void 0])).toBe(3);
  });
  it("should calc size of primitives", () => {
    expect(size("hello")).toBe(5);
    expect(size(3)).toBe(0);
    expect(size(true)).toBe(0);
    expect(size(null)).toBe(0);
    expect(size(void 0)).toBe(0);
    expect(size(Number.NaN)).toBe(0);
  });
});
describe("empty", () => {
  it("should calc empty of map", () => {
    const map = /* @__PURE__ */ new Map();
    expect(empty(map)).toBe(true);
    map.set("a", 1);
    map.set("b", 2);
    expect(empty(map)).toBe(false);
  });
  it("should calc empty of set", () => {
    const set = /* @__PURE__ */ new Set();
    expect(empty(set)).toBe(true);
    set.add(1);
    set.add(2);
    set.add(3);
    expect(empty(set)).toBe(false);
  });
  it("should calc empty of object", () => {
    expect(empty({})).toBe(true);
    expect(empty({ a: 1, b: 2 })).toBe(false);
  });
  it("should calc empty of array", () => {
    expect(empty([])).toBe(true);
    expect(empty([void 0])).toBe(false);
    expect(empty([1, 2, void 0])).toBe(false);
  });
  it("should calc empty of primitives", () => {
    expect(empty("")).toBe(true);
    expect(empty("hello")).toBe(false);
    expect(empty(3)).toBe(true);
    expect(empty(0)).toBe(true);
    expect(empty(false)).toBe(true);
    expect(empty(true)).toBe(true);
    expect(empty(null)).toBe(true);
    expect(empty(void 0)).toBe(true);
    expect(empty(Number.NaN)).toBe(true);
  });
  it("should ensure key", () => {
    const rooms = {};
    ensureKey(rooms, "a", (r) => ({ r })).x = 1;
    expect(rooms).toMatchInlineSnapshot(`
      Object {
        "a": Object {
          "r": "a",
          "x": 1,
        },
      }
    `);
    ensureKey(rooms, "a", (r) => ({ r })).x += 10;
    expect(rooms).toMatchInlineSnapshot(`
      Object {
        "a": Object {
          "r": "a",
          "x": 11,
        },
      }
    `);
  });
  it("should repeat forTimes", () => {
    const l = [];
    forTimes(10, (...args) => l.push(args));
    expect(l).toMatchInlineSnapshot(`
      Array [
        Array [
          0,
          10,
        ],
        Array [
          1,
          10,
        ],
        Array [
          2,
          10,
        ],
        Array [
          3,
          10,
        ],
        Array [
          4,
          10,
        ],
        Array [
          5,
          10,
        ],
        Array [
          6,
          10,
        ],
        Array [
          7,
          10,
        ],
        Array [
          8,
          10,
        ],
        Array [
          9,
          10,
        ],
      ]
    `);
  });
  it("should memoize", () => {
    let ctr = 1;
    const fn = memoize((inc) => {
      ctr += inc;
      return ctr;
    });
    expect(fn(10)).toBe(11);
    expect(fn(10)).toBe(11);
    expect(fn(1)).toBe(12);
    expect(ctr).toBe(12);
  });
  it("should memoize async", async () => {
    let ctr = 1;
    const fn = memoizeAsync(async (inc) => {
      await sleep(10);
      ctr += inc;
      return ctr;
    });
    expect(await fn(10)).toBe(11);
    expect(await fn(10)).toBe(11);
    expect(await fn(1)).toBe(12);
    expect(ctr).toBe(12);
  });
});
//# sourceMappingURL=utils.spec.js.map