interface Pipe<PipeObjectData = object, PipeRawData = PipeObjectData> {
    /** Function to post raw message */
    post: (data: PipeObjectData) => Promise<void> | void;
    /** Listener to receive raw message */
    on: (fn: (data: PipeObjectData) => Promise<void> | void) => void;
    /** Custom function to serialize data */
    serialize?: (data: PipeObjectData) => Promise<PipeRawData> | PipeRawData;
    /** Custom function to deserialize data */
    deserialize?: (data: PipeRawData) => Promise<PipeObjectData> | PipeObjectData;
}

export type { Pipe };
