"use strict";

var _chunkTN2CSMRNcjs = require('../chunk-TN2CSMRN.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-QU2LM4AI.cjs');
require('../chunk-7FPSHSSO.cjs');

// src/node/filestorage.spec.ts
describe("fileStorage", () => {
  it("should store data and read it again", () => {
    {
      const db = new (0, _chunkTN2CSMRNcjs.FileStorage)();
      db.clear();
      expect(db.allKeys()).toEqual([]);
      db.setItem("a", 1);
      db.setItem("b", { complex: [1, 2, "3"] });
      db.setItem("c", [0, 9, 8]);
      db.setItem("c", "Again!");
      expect(db.allKeys()).toEqual(["a", "b", "c"]);
      expect(db.getItem("a")).toEqual(1);
      expect(db.getItem("b")).toEqual({ complex: [1, 2, "3"] });
      expect(db.getItem("c")).toEqual("Again!");
      expect(db.getItem("d")).toBe(void 0);
      expect(db.getItem("d")).toBe(void 0);
      db.setItem("e", "xxx");
      db.removeItem("e");
      expect(db.getItem("e")).toBe(void 0);
    }
    {
      const db = new (0, _chunkTN2CSMRNcjs.FileStorage)();
      expect(db.allKeys()).toEqual(["a", "b", "c"]);
      expect(db.getItem("a")).toEqual(1);
      expect(db.getItem("b")).toEqual({ complex: [1, 2, "3"] });
      expect(db.getItem("c")).toEqual("Again!");
      db.removeItem("b");
      expect(db.allKeys()).toEqual(["a", "c"]);
      db.clear();
      expect(db.allKeys()).toEqual([]);
    }
  });
});
//# sourceMappingURL=filestorage.spec.cjs.map